#include "feature.h"
#include "meeple.h"

int Feature::s_counter = 0;

Feature::Feature()
{
	m_number = s_counter++;

	m_openBorders = 0;
	m_tileCount = 1;
	m_isComplete = false;
}

Feature::~Feature()
{
	SayDestroy();
}

void Feature::SayInfo()
{
	cout << m_name << " " << m_number << ": " << m_openBorders << " open borders, "
		<< m_tileCount << " tiles, " << m_meeples.size() << " meeples.\n";
}

bool Feature::IsNowCompleted()
{
	if(m_isComplete)
		return false;

	if(m_openBorders == 0) {
		m_isComplete = true;
		return true;
	}
	
	return false;
}

void Feature::Complete()
{
	for(unsigned i=0;i<m_meeples.size();i++)
		m_meeples[i]->Free();
}

void Feature::Merge(Feature *pFeature)
{
	m_openBorders += pFeature->GetOpenBorders();

	for(int i=0;i<pFeature->NumOfMeeples();i++)
		m_meeples.push_back(pFeature->GetMeeple(i));
}

void Feature::AddMeeple(Meeple *pMeeple)
{
	m_meeples.push_back(pMeeple);
}
