#pragma once

#include <iostream>
#include <string>
#include <vector>
using namespace std;

class Meeple;

class Feature
{
public:
	Feature();
	virtual ~Feature();

	virtual void SayCreate() { cout << "Creating " << m_name << ": " << m_number << endl; }
	virtual void SayDestroy() { cout << "Destroying " << m_name << ": " << m_number << endl; }
	virtual void SayInfo();
	
	virtual bool IsComplete() const { return m_isComplete; }
	virtual bool IsNowCompleted();
	virtual void Complete();

	virtual void IncreaseBorderCount() { m_openBorders++; }
	virtual void DropBorderCount() { m_openBorders--; }
	virtual int GetOpenBorders() const { return m_openBorders; }

	virtual void ZeroTileCount() { m_tileCount = 0; }
	virtual void IncreaseTileCount() { m_tileCount++; }

	virtual void Merge(Feature *pFeature);

	virtual void AddMeeple(Meeple *pMeeple);
	virtual int NumOfMeeples() const { return m_meeples.size(); }
	virtual Meeple *GetMeeple(int i) const { return m_meeples[i]; }

	int m_number;
protected:
	static int s_counter;
	string m_name;

	vector <Meeple *> m_meeples;
	int m_openBorders;
	int m_tileCount;
	bool m_isComplete;
};
