#pragma once

#include "sdlwindow.h"
#include "sdlinput.h"
#include "tile.h"

#include <vector>
#include <map>
using namespace std;

typedef map <Point, Tile *>::iterator TileIt;

class Game: public Window
{
public:
	Game();
	virtual ~Game();

	virtual void Initialize();
	virtual void Draw();
	virtual void Update(double dt);

	virtual void OnKeyDown(Key& key);
	virtual void OnButtonDown(Button& button);
	virtual void OnWheelUp(Button& button);
	virtual void OnWheelDown(Button& button);
	virtual void OnMouseMove(Motion& motion);

protected:
	bool CanPlaceTile(Point p, Tile *pTile);
	bool PlaceTile(Point p, Tile *pTile);
	void Attach(Tile *pTile1, Tile *pTile2, DIR direction);
	
	void Add(vector <Feature *> add);
	void Delete(vector <Feature *> remove);

protected:
	Point ScreenToGrid(Point p);

protected:
	Player m_player;
	map <Point, Tile *> m_tiles;
	vector <Feature *> m_features;

	Tile *m_pTile, *m_pJustPlaced;
	vector <Feature *> m_added;
	vector <string> m_tileNames;
	bool m_tilesPlaced;

// Graphics data
protected:
	Point m_offset, m_tileSize;
	double m_zoom, m_zoomSpeed;
};
