#include "meeple.h"
#include "feature.h"
#include "tile.h"
#include "farm.h"

Image Meeple::s_image, Meeple::s_mask;
bool Meeple::s_loaded = false;

Meeple::Meeple(Player *pOwner): m_pOwner(pOwner), m_pHome(0), m_pTile(0)
{
	if(!s_loaded) {
		s_loaded = true;
		s_image.LoadBitmap("Data/meeple.bmp", LINEAR);
		s_mask.LoadBitmap("Data/meeple_mask.bmp", LINEAR);
	}
}

Meeple::~Meeple()
{

}

void Meeple::Draw(double size)
{
	glTranslatef(m_p.m_x * size, m_p.m_y * size, 0);

	if(dynamic_cast <Farm *> (m_pHome)) {
		glTranslatef(.5 * size, .5 * size, 0);
		glRotatef(-140, 0, 0, 1);
		glTranslatef(-.5 * size, -.5 * size, 0);
	}

	glColor3f(1, 1, 1);
	glBlendFunc(GL_DST_COLOR,GL_ZERO);
	s_mask.Bind();
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0); glVertex2f(0,	0);
		glTexCoord2f(1, 0); glVertex2f(size,	0);
		glTexCoord2f(1, 1); glVertex2f(size,	size);
		glTexCoord2f(0, 1); glVertex2f(0,	size);
	glEnd();
	s_mask.UnBind();

	glColor3f(1, 1, 1);
	glBlendFunc(GL_ONE, GL_ONE);
	s_image.Bind();
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0); glVertex2f(0,	0);
		glTexCoord2f(1, 0); glVertex2f(size,	0);
		glTexCoord2f(1, 1); glVertex2f(size,	size);
		glTexCoord2f(0, 1); glVertex2f(0,	size);
	glEnd();
	s_image.UnBind();

	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

//	GLUquadricObj *pQuad = gluNewQuadric();
//	gluDisk(pQuad, 0, size / 2, 10, 10);
//	gluDeleteQuadric(pQuad);
	
	if(dynamic_cast <Farm *> (m_pHome)) {
		glTranslatef(.5 * size, .5 * size, 0);
		glRotatef(140, 0, 0, 1);
		glTranslatef(-.5 * size, -.5 * size, 0);
	}

	glTranslatef(-m_p.m_x * size, -m_p.m_y * size, 0);
}

void Meeple::Place(Feature *pHome, Tile *pTile, Point p)
{
	m_pHome = pHome;
	m_pTile = pTile;
	m_p = p;

	pHome->AddMeeple(this);
}

void Meeple::Free()
{
	if(!m_pTile)
		return;

	m_pTile->ReturnMeeple();

	m_pHome = 0;
	m_pTile = 0;
}
