#pragma once

#include "point.h"
#include "image.h"

class Player;
class Feature;
class Tile;

class Meeple
{
public:
	Meeple(Player *pOwner);
	~Meeple();

	void Draw(double size);

	void Place(Feature *pHome, Tile *pTile, Point p);
	void Free();
	bool IsOccupied() const { return (m_pHome != 0); }

private:
	Player *m_pOwner;
	Feature *m_pHome;
	Tile *m_pTile;
	Point m_p;

	static Image s_image, s_mask;
	static bool s_loaded;
};
