#include "point.h"

DIR GetDirection(string str)
{
	if(str == "north")
		return NORTH;
	if(str == "east")
		return EAST;
	if(str == "south")
		return SOUTH;
	if(str == "west")
		return WEST;

	return NORTH;
}

DIR Opposite(DIR direction)
{
	switch(direction) {
		case NORTH: return SOUTH;
		case EAST: return WEST;
		case SOUTH: return NORTH;
		case WEST: return EAST;
		case NORTHEAST: return SOUTHWEST;
		case SOUTHEAST: return NORTHWEST;
		case SOUTHWEST: return NORTHEAST;
		case NORTHWEST: return SOUTHEAST;
		default: return NORTH;
	}
	
	return NORTH;
}

DIR TurnCW(DIR direction)
{
	switch(direction) {
		case NORTH: return EAST;
		case EAST: return SOUTH;
		case SOUTH: return WEST;
		case WEST: return NORTH;
		default: return NORTH;
	}
	
	return NORTH;
}

DIR TurnCCW(DIR direction)
{
	switch(direction) {
		case NORTH: return WEST;
		case EAST: return NORTH;
		case SOUTH: return EAST;
		case WEST: return SOUTH;
		default: return NORTH;
	}
	
	return NORTH;
}

DIR RotateBy(DIR direction, DIR orientation)
{
	for(int i=0;i<orientation;i++)
		direction = TurnCCW(direction);

	return direction;
}

int GetRotation(DIR direction)
{
	switch(direction) {
		case NORTH: return 0;
		case EAST: return 90;
		case SOUTH: return 180;
		case WEST: return 270;
		case NORTHEAST: return 45;
		case SOUTHEAST: return 135;
		case SOUTHWEST: return 225;
		case NORTHWEST: return 315;
		default: return 0;
	}
	
	return 0;
}

Point Point::GetNeighbor(DIR direction, int flipY)
{
	switch(direction) {
		case NORTH: return Point(m_x, m_y + flipY);
		case EAST: return Point(m_x + 1, m_y);
		case SOUTH: return Point(m_x, m_y - flipY);
		case WEST: return Point(m_x - 1, m_y);
		case NORTHEAST: return Point(m_x + 1, m_y + flipY);
		case SOUTHEAST: return Point(m_x + 1, m_y - flipY);
		case SOUTHWEST: return Point(m_x - 1, m_y - flipY);
		case NORTHWEST: return Point(m_x - 1, m_y + flipY);
	}

	return (*this);
}

bool operator < (const Point p1, const Point p2)
{
	if(p1.m_x < p2.m_x)
		return true;

	if(p1.m_x > p2.m_x)
		return false;

	if(p1.m_y < p2.m_y)
		return true;

	return false;
}

Point RotateBy(Point p, DIR direction, int size)
{
	switch(direction) {
		case NORTH: return p;
		case EAST: return Point(size - p.m_y, p.m_x);
		case SOUTH: return Point(size - p.m_x, size - p.m_y);
		case WEST: return Point(p.m_y, size - p.m_x);
		default: break;
	}
	
	return p;
}

Point RotateFrom(Point p, DIR direction, int size)
{
	switch(direction) {
		case NORTH: return p;
		case EAST: return Point(p.m_y, size - p.m_x);
		case SOUTH: return Point(size - p.m_x, size - p.m_y);
		case WEST: return Point(size - p.m_y, p.m_x);
		default: break;
	}
	
	return p;
}
