#pragma once

#include <string>
using namespace std;

inline int Floor(double a)
{
	if(a >= 0)
		return (int) a;

	return -Floor(-a) - 1;
}

enum DIR { NORTH, EAST, SOUTH, WEST, NORTHEAST, SOUTHEAST, SOUTHWEST, NORTHWEST };
const string Dir[] = { "north", "east", "south", "west", "northeast", "southeast", "southwest", "northwest" };

DIR GetDirection(string str);
DIR Opposite(DIR direction);
DIR TurnCW(DIR direction);
DIR TurnCCW(DIR direction);
DIR RotateBy(DIR direction, DIR orientation);
int GetRotation(DIR direction);

class Point
{
public:
	Point(): m_x(0), m_y(0) {}
	Point(int x, int y): m_x(x), m_y(y) {}
	Point(const Point& p): m_x(p.m_x), m_y(p.m_y) { }

	void Set(int x, int y) { m_x = x; m_y = y; }
	void Set(Point p) { m_x = p.m_x; m_y = p.m_y; }

	Point GetNeighbor(DIR direction, int flipY = -1);

	friend bool operator < (const Point p1, const Point p2);

	int m_x, m_y;
};

Point RotateBy(Point p, DIR orientation, int size);
Point RotateFrom(Point p, DIR orientation, int size);

