#pragma once

#include "SDL.h"

typedef SDL_KeyboardEvent Key;
typedef SDL_MouseButtonEvent Button;
typedef SDL_MouseMotionEvent Motion;

class Window;

class Mouse
{
public:
	Mouse(): m_x(0), m_y(0) { m_buttons[0] = false; m_buttons[1] = false; }

	void MoveTo(int x, int y);

	int m_x, m_y;
	bool m_buttons[2];
};

class Keyboard
{
public:
	Keyboard();
	
	void KeyDown(SDLKey key);
	void KeyUp(SDLKey key);

	bool m_keys[255];
};

class Input
{
public:
	Input(Window *pWindow);
	~Input();
	
	void MoveMouse(Motion& motion);
	void ButtonDown(Button& button);
	void ButtonUp(Button& button);
	
	void KeyDown(Key& key);
	void KeyUp(Key& key);

	void GetMouseCoords(int& x, int& y);
	bool IsModDown(SDLMod mod);

private:
	Window *m_pWindow;

	Mouse m_mouse;
	Keyboard m_keyboard;
};
